<template>
  <button :class="classes" @click="handleClick">
    <slot />
  </button>
</template>

<script setup lang="ts">
import { computed } from 'vue';
import { ButtonColor, ButtonSize } from './button.types';
import { COLOR_CLASS, SIZE_CLASS } from './button.constants';

interface ButtonProps {
  size: ButtonSize;
  color?: ButtonColor;
  active?: boolean;
}

const props = withDefaults(defineProps<ButtonProps>(), {
  size: 'md',
  color: 'primary',
});

const emit = defineEmits<{
  (e: 'click', originalEvent: MouseEvent): void;
}>();

const sizeClass = computed(() => {
  return SIZE_CLASS[props.size];
});

const colorClass = computed(() => {
  return COLOR_CLASS[props.color];
});

const activeClass = computed(() => {
  return props.active ? 'active' : '';
});

const classes = computed(() => {
  return ['btn', sizeClass.value, colorClass.value, activeClass.value].join(
    ' '
  );
});

const handleClick = (e: MouseEvent) => {
  emit('click', e);
};
</script>
